<?php

// Check nonce
PHPCUS_PARAM::CUS_REQUIRES_NONCE();

// Check Array Input
PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();

// Check already authenticated
PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

// Check access rights
PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'mobile_outbox');


if
(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
				[
						'PARAM_OUTBOX_ID',
						'PARAM_OUTBOX_TRANSACTION_ID',
						'PARAM_OUTBOX_SHORTCODE',
						'PARAM_OUTBOX_COMPANY_CODE',
						
						'PARAM_OUTBOX_MOBILE_NUMBER',
						'PARAM_OUTBOX_MESSAGE',
						'PARAM_OUTBOX_TIMESTAMP_FROM',
						'PARAM_OUTBOX_TIMESTAMP_TO',
						'PARAM_OUTBOX_RESULT',
						'PARAM_OUTBOX_STATUS',
						
						'PARAM_ORDER_FIELD',
						'PARAM_ORDER_TYPE',
						'PARAM_SKIP'
				], True
				)
		)
{
	Try
	{
		// Read params
		// ------------------------------------------------------------------
		
		$PARAM_OUTBOX_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_OUTBOX_ID');
		$PARAM_OUTBOX_TRANSACTION_ID = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_OUTBOX_TRANSACTION_ID');
		$PARAM_OUTBOX_SHORTCODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_OUTBOX_SHORTCODE');
		$PARAM_OUTBOX_COMPANY_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_OUTBOX_COMPANY_CODE');
		
		$PARAM_OUTBOX_MOBILE_NUMBER = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_OUTBOX_MOBILE_NUMBER');
		$PARAM_OUTBOX_MESSAGE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_OUTBOX_MESSAGE');
		$PARAM_OUTBOX_TIMESTAMP_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_OUTBOX_TIMESTAMP_FROM');
		$PARAM_OUTBOX_TIMESTAMP_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_OUTBOX_TIMESTAMP_TO');
		$PARAM_OUTBOX_RESULT = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_OUTBOX_RESULT');
		$PARAM_OUTBOX_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_OUTBOX_STATUS');
		
		$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
		(
				'PARAM_ORDER_FIELD',
				[
						'OUTBOX_ID',
						'OUTBOX_TRANSACTION_ID',
						'OUTBOX_SHORTCODE',
						'OUTBOX_COMPANY_CODE',
						
						'OUTBOX_MOBILE_NUMBER',
						'OUTBOX_MESSAGE',
						'OUTBOX_TIMESTAMP',
						'OUTBOX_RESULT',
						'OUTBOX_STATUS'
				]
		);
		
		$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
		$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
		
		// ------------------------------------------------------------------
		
		
		// Execute Stored Procedure
		$DATA_SET = PHPCUS_MOBILE_OUTBOX::CUS_GET
		(
				$PARAM_OUTBOX_ID,
				$PARAM_OUTBOX_TRANSACTION_ID,
				$PARAM_OUTBOX_SHORTCODE,
				$PARAM_OUTBOX_COMPANY_CODE,
				
				$PARAM_OUTBOX_MOBILE_NUMBER,
				$PARAM_OUTBOX_MESSAGE,
				$PARAM_OUTBOX_TIMESTAMP_FROM,
				$PARAM_OUTBOX_TIMESTAMP_TO,
				$PARAM_OUTBOX_RESULT,
				$PARAM_OUTBOX_STATUS,
				
				$PARAM_ORDER_FIELD,
				$PARAM_ORDER_TYPE,
				$PARAM_SKIP
		);
		
		// Return JSON response
		if(empty($DATA_SET) === False)
		{
			PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
		}
		else
		{
			PHPCUS_PARAM::CUS_JSON_SUCCESS('');
		}
		
	}
	Catch(Exception $ERR)
	{
		PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
		PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
	}
}
else
{
	PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
}

?>